
#include <set>
#include <iostream>
using namespace std;

#include <stdlib.h>
#include <time.h>

#define MAX 5

namespace Outrora
{

void sementear()
{
    time_t t;                   // https://pt.wikipedia.org/wiki/Time_t
    srand((unsigned) time(&t)); // Para funo srand e rand vide: https://www.tutorialspoint.com/c_standard_library/c_function_srand.htm
}

class Humanus
{
    private:
        short int idade;

    protected:
        bool flag;

    protected: //public:
        virtual void informar() const { cout << "O valor da idade de " << this << "eh: " << idade << endl; }
        void operator++() { idade++; }
        //void setIdade (const int i) { idade = i; }
        const int getIdade() const { return (int)idade; }

    public:

        Humanus(const bool flg = false) :
            idade (rand()%30),
            flag(flg)
        {
            sementear();
        }

        virtual ~Humanus()
        {
            //cout << "Rodando a destrutora de Humanus para: " << this << endl;
            idade=-1;
        }

        const bool getFlag() const { return flag; }

        virtual void envelhecer() = 0;
};

class Sapiens : public Humanus
{
    private:
        bool xy;
        static short int cont;
        static short int soma_idade;

    public:

        Sapiens(const bool flg = false):
            Humanus(flg),
            xy((rand()%10)<4)
        {
            sementear();
            cont++;
            soma_idade += getIdade();
        }

        virtual ~Sapiens()
        {
            //cout << "Rodando a destrutora de Sapiens para: " << this << endl;
            cont--;
            soma_idade -= getIdade();
        }

        //void setFerrao(const bool f) { ferrao = f; } // at o implementei mas no  usado finalmente...
        const bool getXY() const { return xy; }

        const int getIdade() const { return Humanus::getIdade();; }

        void envelhecer()
        {
            soma_idade-=getIdade();
            operator++();
            soma_idade+=getIdade();

            informar();

            // O que segue no era necessrio na execuo da prova
            cout << "Aniversario do Sapiens: " << this << endl;
            cout << "Dinmico? " << endl;
            getFlag() ? cout << "sim!" : cout << "no!";
            cout << endl;
        }

        static const int getMediaIdade() { return static_cast<int>(soma_idade / cont);  }
        //static const int getMediaIdade() { return (int)(soma_idade / cont);  }

};

short int Sapiens::cont(0);
short int Sapiens::soma_idade(0);

class Hibrido;

class Neandertal : public Humanus
{
    private:
        bool xx;
    public:

        Neandertal(const bool flg = false):
            Humanus(flg),
            xx((rand()%10)<6)
        {
            sementear();
        }

        ~Neandertal()
        {
            //cout << "Rodando a destrutora de Neandertal para: " << this << endl;
        }

        void envelhecer()
        {
            operator++();
            if (!xx) operator++();
            informar();

            // O que segue no era necessrio na execuo da prova
            cout << "Aniversario do Neandertal: " << this << endl;
            cout << "Dinmico? " << endl;
            getFlag() ? cout << "sim!" : cout << "no!";
            cout << endl;
        }

        Hibrido* misegenar(Sapiens& pSap); // implementado depois dado a dependncia de Hibrido.

};

// https://www.geeksforgeeks.org/virtual-base-class-in-c/

class Hibrido : virtual public Sapiens, virtual public Neandertal
{
    private:
        bool saudavel;

    protected: //public:
        void informar()
        {
            //cout << "O valor da idade de " << this << "eh: " << Sapiens::getIdade() << endl;
            Sapiens::informar();

            cout << "Saudvel? " <<  endl;
            saudavel ? cout << "sim!" : cout << "no!";
            cout << endl;
        }

    public:
        Hibrido(const bool flg = true) :
            Sapiens (flg),
            Neandertal(flg),
            saudavel( (bool)rand()%999 )
        {
            sementear();
        }
        ~Hibrido()
        {
            //cout << "Rodando a destrutora de Hibrido para: " << this << endl;
            informar();
        }

        //bool getSaudavel() { return saudavel; }

        // void envelhecer() { cout << "Teste!" << endl; system("Pause"); }

};

Hibrido* Neandertal::misegenar(Sapiens& pSap)
{
    if (pSap.getXY())
    {
        if (xx)
        {
            if (getIdade() > 20)
            {
                if (pSap.getIdade() > 20)
                {
                    Hibrido* p = NULL;
                    p = new Hibrido(true);
                    cout << "Nasceu um Hibrido!" << p << endl;
                    return (p);
                } else {}
            }else { }
        }
        else
        {
            cout << "O seguinte Neandertal " << this << " no  XX em seu prprio misegenar." << endl;
        }
    }
    else
    {
        cout << "O seguinte Sapiens " << &pSap << " no  XY em misegenar de " << this << endl;
    }
    return NULL;
}

class Sociedade
{
    private:
        Sapiens sapi[5];
        Neandertal neandi[5];
        set<Humanus*> humani;

    private:
        void misegenar()
        {
            Hibrido* prole = NULL;

            for (int i = 0; i < MAX; i++)
            {
                prole = neandi[i].misegenar(sapi[i]);
                if (prole)
                {
                    humani.insert(static_cast<Humanus*>(static_cast<Sapiens*>(prole)));
                    //humani.insert(static_cast<Sapiens*>(prole));
                    //humani.insert(dynamic_cast<Sapiens*>(prole));
                }
                else
                {
                    cout << "Sem prole entre casal Sapo-neandertal nmero: " << i << endl;
                }
            }
        }

        void desalocar()
        {
            //set<Humanus*>::iterator it;
            set<Humanus*>::const_iterator it;
            it = humani.begin();

            while (it != humani.end())
            {
                if (*it)
                {
                    if ((*it)->getFlag())
                    {
                        delete *it;
                    }
                }
                it++;
            }
            humani.clear();
        }

    public:
        Sociedade(): sapi(), neandi(), humani()
        {
            humani.clear();
            for (int i = 0; i < MAX; i++)
            {
                humani.insert(static_cast<Sapiens*>(&sapi[i]));
                humani.insert(static_cast<Neandertal*>(&neandi[i]));
            }
        }
        ~Sociedade()
        {
            //cout << "Rodando a destrutora de Sociedade para: " << this << endl;
            desalocar();
        }

        void executar()
        {

            const int X = Sapiens::getMediaIdade();
            //const int X = 2;

            cout << "A media de idade de sapiens eh: " << X << endl << endl;

            for (int i = 0; i < X; i++)
            {
                cout << "Lao nmero: " << i << endl << endl;

                misegenar();

                set<Humanus*>::const_iterator it;

                for ( it = humani.begin(); it != humani.end(); it++)
                {
                    if (*it)
                    {
                        cout << endl; (*it)->envelhecer();
                    }
                    else
                    {
                        cout << "Ponteiro nulo no conjunto" << endl;
                    }
                }
                cout << endl;
            }
        }
};
} using namespace Outrora;

int main()
{
    sementear();

    /*Humanus* p = NULL;
    Hibrido h;
    p = static_cast<Sapiens*>(&h);
    p->informar();
    h.informar();*/

    //Sapiens s;

    Sociedade primitiva;
    primitiva.executar();

    return 0;
}
